//+------------------------------------------------------------------+
//|                                               MTF BAT ATR v3.mq4 |
//|                                         from other MTF indicator |
//+------------------------------------------------------------------+
#property copyright "mason"

#property  indicator_chart_window
#property  indicator_buffers 8
#property  indicator_color1  Green
#property  indicator_width1  2
#property  indicator_style1  1
#property  indicator_color2  Maroon
#property  indicator_width2  2
#property  indicator_style2  1
#property  indicator_color3  Green
#property  indicator_width3  3
#property  indicator_style3  1
#property  indicator_color4  Maroon
#property  indicator_width4  3
#property  indicator_style4  1
#property  indicator_color5  Green
#property  indicator_width5  4
#property  indicator_style5  1
#property  indicator_color6  Maroon
#property  indicator_width6  4
#property  indicator_style6  1
#property  indicator_color7  Green
#property  indicator_width7  5
#property  indicator_style7  1
#property  indicator_color8  Maroon
#property  indicator_width8  5
#property  indicator_style8  1

//---- input parameters
/*************************************************************************
PERIOD_M1   1
PERIOD_M5   5
PERIOD_M15  15
PERIOD_M30  30 
PERIOD_H1   60
PERIOD_H4   240
PERIOD_D1   1440
PERIOD_W1   10080
PERIOD_MN1  43200
You must use the numeric value of the timeframe that you want to use
when you set the TimeFrame' value with the indicator inputs.
**************************************************************************/
//---- indicator parameters
extern int             FirstDir      = 0;
extern string          ArrowName     = "PB";
extern int             HowmanyTF     = 2;
extern int             TimeFrame     = 0;
extern int             ATRPeriod1    = 3;
extern double          Factor1       = 3;
extern bool            CloseBase1    = true;
extern int             ATRPeriod2    = 2;
extern double          Factor2       = 1;
extern bool            CloseBase2    = true;
extern int             ATRPeriod3    = 2;
extern double          Factor3       = 1;
extern bool            CloseBase3    = true;
extern int             ATRPeriod4    = 2;
extern double          Factor4       = 1;
extern bool            CloseBase4    = true;
extern bool            MedianPrice   = true;
extern bool            MedianBase    = true;
extern double          Vdistance      = 0;
extern int             Hshift        = 0;
extern double          Vshift        = 0;
extern bool            Continuous    = true;
extern int             BackPeriod    = 0;
extern datetime        PBdatetime    = NULL;

double ind_buffer1[];
double ind_buffer2[];
double ind_buffer3[];
double ind_buffer4[];
double ind_buffer5[];
double ind_buffer6[];
double ind_buffer7[];
double ind_buffer8[];

int Period_1, Period_2, Period_3, Period_4;
int ATRPeriod;
bool CloseBase;
double Factor;
int limit,pos;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;

//---- indicator line
   SetIndexStyle(0,DRAW_LINE);
   SetIndexDrawBegin(0,ATRPeriod);
   SetIndexBuffer(0,ind_buffer1);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexDrawBegin(1,ATRPeriod);
   SetIndexBuffer(1,ind_buffer2);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexDrawBegin(2,ATRPeriod);
   SetIndexBuffer(2,ind_buffer3);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexDrawBegin(3,ATRPeriod);
   SetIndexBuffer(3,ind_buffer4);
   SetIndexStyle(4,DRAW_LINE);
   SetIndexDrawBegin(4,ATRPeriod);
   SetIndexBuffer(4,ind_buffer5);
   SetIndexStyle(5,DRAW_LINE);
   SetIndexDrawBegin(5,ATRPeriod);
   SetIndexBuffer(5,ind_buffer6);
   SetIndexStyle(6,DRAW_LINE);
   SetIndexDrawBegin(6,ATRPeriod);
   SetIndexBuffer(6,ind_buffer7);
   SetIndexStyle(7,DRAW_LINE);
   SetIndexDrawBegin(7,ATRPeriod);
   SetIndexBuffer(7,ind_buffer8);
//---- name for DataWindow and indicator subwindow label   

   switch(Period()) 
      {
         case 1: 
            Period_1=1; Period_2=5; Period_3=15; Period_4=30; 
            break;
         case 5: 
            Period_1=5; Period_2=15; Period_3=30; Period_4=60; 
            break;
         case 15: 
            Period_1=15; Period_2=30; Period_3=60; Period_4=240; 
            break;
         case 30: 
            Period_1=30; Period_2=60; Period_3=240; Period_4=1440; 
            break;
         case 60: 
            Period_1=60; Period_2=240; Period_3=1440; Period_4=10080; 
            break;
         case 240: 
            Period_1=240; Period_2=1440; Period_3=10080; Period_4=43200; 
            break;
         case 1440: 
            Period_1=1440; Period_2=10080; Period_3=43200; Period_4=43200; 
            break;
         case 10080: 
            Period_1=10080; Period_2=43200; Period_3=43200; Period_4=43200; 
            break;
         case 43200: 
            Period_1=43200; Period_2=43200; Period_3=43200; Period_4=43200; 
            break;
      }

   switch(TimeFrame)
   {
      case 1 : string TimeFrameStr="Period_M1"; break;
      case 5 : TimeFrameStr="Period_M5"; break;
      case 15 : TimeFrameStr="Period_M15"; break;
      case 30 : TimeFrameStr="Period_M30"; break;
      case 60 : TimeFrameStr="Period_H1"; break;
      case 240 : TimeFrameStr="Period_H4"; break;
      case 1440 : TimeFrameStr="Period_D1"; break;
      case 10080 : TimeFrameStr="Period_W1"; break;
      case 43200 : TimeFrameStr="Period_MN1"; break;
      default : TimeFrameStr="Current Timeframe";
   } 
   
   if (HowmanyTF==0) { 
       SetIndexLabel(0,"Support");
       SetIndexLabel(1,"Resistance");
       IndicatorShortName("MTF BAT ATR v3("+ATRPeriod1+","+DoubleToStr(Factor1,1)+") "+TimeFrameStr);
   }
   else {
       SetIndexLabel(0,"Support "+tf2txt(Period_1));
       SetIndexLabel(1,"Resistance "+tf2txt(Period_1));
       SetIndexLabel(2,"Support "+tf2txt(Period_2));
       SetIndexLabel(3,"Resistance "+tf2txt(Period_2));
       SetIndexLabel(4,"Support "+tf2txt(Period_3));
       SetIndexLabel(5,"Resistance "+tf2txt(Period_3));
       SetIndexLabel(6,"Support "+tf2txt(Period_4));
       SetIndexLabel(7,"Resistance "+tf2txt(Period_4));
       IndicatorShortName("MTF BAT ATR v3("+ATRPeriod1+","+DoubleToStr(Factor1,1)+","+tf2txt(Period_1)+","+tf2txt(Period_2)+","+tf2txt(Period_3)+","+tf2txt(Period_4)+") ");
   }   
   
    if ((ObjectGet(ArrowName,OBJPROP_ARROWCODE)==67)&&(PBdatetime==NULL)) {
       PBdatetime = ObjectGet(ArrowName,OBJPROP_TIME1);
       pos = iBarShift(NULL,0,PBdatetime,true)+Hshift;
    }
    else if (PBdatetime!=NULL) pos=iBarShift(NULL,0,PBdatetime,false)+Hshift;
    else {
        pos=0;
    }

  }
//----
   return(0);
 
//+------------------------------------------------------------------+
//| MTF Moving Average                                   |
//+------------------------------------------------------------------+
int start()
  {
   datetime TimeArray[];
   datetime TimeArray1[], TimeArray2[], TimeArray3[], TimeArray4[];
   int i,y=0,counted_bars=IndicatorCounted()-1;
   int y1=0, y2=0, y3=0, y4=0,yy;
   double mtfbatsupp,mtfbatress;
   
   limit=Bars-counted_bars;
   if (pos>0) limit=pos+1;

   if (HowmanyTF==0) { 
       ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TimeFrame); 
       for(i=0,y=0;i<limit;i++)
       {
       if (Time[i]<TimeArray[y]) y++; 
          ind_buffer1[i]=iCustom(NULL,TimeFrame,"BAT ATR v3",FirstDir,ArrowName,ATRPeriod1,Factor1,MedianPrice,MedianBase,CloseBase1,Vdistance,Hshift,Vshift,Continuous,BackPeriod,PBdatetime,0,y);
          ind_buffer2[i]=iCustom(NULL,TimeFrame,"BAT ATR v3",FirstDir,ArrowName,ATRPeriod1,Factor1,MedianPrice,MedianBase,CloseBase1,Vdistance,Hshift,Vshift,Continuous,BackPeriod,PBdatetime,1,y);
       }
    }
   else {
      ArrayCopySeries(TimeArray4,MODE_TIME,Symbol(),Period_4); 
      ArrayCopySeries(TimeArray3,MODE_TIME,Symbol(),Period_3); 
      ArrayCopySeries(TimeArray2,MODE_TIME,Symbol(),Period_2);
      ArrayCopySeries(TimeArray1,MODE_TIME,Symbol(),Period_1); 

      for(i=0,y1=0,y2=0,y3=0,y4=0;i<limit;i++)
      {
         if (Time[i]<TimeArray1[y1]) y1++;
         if (Time[i]<TimeArray2[y2]) y2++;
         if (Time[i]<TimeArray3[y3]) y3++;
         if (Time[i]<TimeArray4[y4]) y4++;

      for (int tf = 0; tf < HowmanyTF; tf++)
      {
         int prd;
         switch (tf)
         {
            case 0: prd = Period_1; 
                    ATRPeriod = ATRPeriod1;
                    Factor = Factor1;
                    CloseBase = CloseBase1;
                    yy = y1;  
                    break;
            case 1: prd = Period_2; 
                    ATRPeriod = ATRPeriod2;
                    Factor = Factor2;
                    CloseBase = CloseBase2;
                    yy = y2;  
                    break;
            case 2: prd = Period_3;  
                    ATRPeriod = ATRPeriod3;
                    Factor = Factor3;
                    CloseBase = CloseBase3;
                    yy = y3;   
                    break;
            case 3: prd = Period_4;  
                    ATRPeriod = ATRPeriod4;
                    Factor = Factor4;
                    CloseBase = CloseBase4;
                    yy = y4;   
                    break;
         }//switch

         mtfbatsupp=iCustom(NULL,prd,"BAT ATR v3",FirstDir,ArrowName,ATRPeriod,Factor,MedianPrice,MedianBase,CloseBase,Vdistance,Hshift,Vshift,Continuous,BackPeriod,PBdatetime,0,yy);
         mtfbatress=iCustom(NULL,prd,"BAT ATR v3",FirstDir,ArrowName,ATRPeriod,Factor,MedianPrice,MedianBase,CloseBase,Vdistance,Hshift,Vshift,Continuous,BackPeriod,PBdatetime,1,yy);
         
         switch (tf)
         {
            case 0: ind_buffer1[i] = mtfbatsupp;           
                    ind_buffer2[i] = mtfbatress;     
                    break;
            case 1: ind_buffer3[i] = mtfbatsupp;           
                    ind_buffer4[i] = mtfbatress;     
                    break;
            case 2: ind_buffer5[i] = mtfbatsupp;           
                    ind_buffer6[i] = mtfbatress;     
                    break;
            case 3: ind_buffer7[i] = mtfbatsupp;           
                    ind_buffer8[i] = mtfbatress;     
                    break;
         }//switch

      } //for
   }   //if
   
   }   //start
     
//
   return(0);
  }
//+------------------------------------------------------------------+


string tf2txt(int tf)
{
   if (tf == PERIOD_M1)    return("M1");
   if (tf == PERIOD_M5)    return("M5");
   if (tf == PERIOD_M15)    return("M15");
   if (tf == PERIOD_M30)    return("M30");
   if (tf == PERIOD_H1)    return("H1");
   if (tf == PERIOD_H4)    return("H4");
   if (tf == PERIOD_D1)    return("D1");
   if (tf == PERIOD_W1)    return("W1");
   if (tf == PERIOD_MN1)    return("MN1");
   
   return("??");
}

